'''base64 encoded image data for testing'''

import base64
import io

from PIL import Image

pixel1x1 = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD//gATQ3JlYXRlZCB3aXRoIEdJTVD/2wBDAIVcZHVkU4V1bHWW
joWeyP/ZyLe3yP////L/////////////////////////////////////////////////////2wBD
AY6WlsivyP/Z2f//////////////////////////////////////////////////////////////
////////////wgARCAABAAEDAREAAhEBAxEB/8QAFAABAAAAAAAAAAAAAAAAAAAAA//EABQBAQAA
AAAAAAAAAAAAAAAAAAD/2gAMAwEAAhADEAAAAUP/xAAUEAEAAAAAAAAAAAAAAAAAAAAA/9oACAEB
AAEFAn//xAAUEQEAAAAAAAAAAAAAAAAAAAAA/9oACAEDAQE/AX//xAAUEQEAAAAAAAAAAAAAAAAA
AAAA/9oACAECAQE/AX//xAAUEAEAAAAAAAAAAAAAAAAAAAAA/9oACAEBAAY/An//xAAUEAEAAAAA
AAAAAAAAAAAAAAAA/9oACAEBAAE/IX//2gAMAwEAAgADAAAAEB//xAAUEQEAAAAAAAAAAAAAAAAA
AAAA/9oACAEDAQE/EH//xAAUEQEAAAAAAAAAAAAAAAAAAAAA/9oACAECAQE/EH//xAAUEAEAAAAA
AAAAAAAAAAAAAAAA/9oACAEBAAE/EH//2Q==''')

with io.BytesIO(pixel1x1) as f:
    pixel1x1_img = Image.open(f)
    pixel1x1_img.load()

png1x1 = base64.b64decode('''
iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAABmJLR0QA/wD/AP+gvaeTAAAACXBI
WXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4wISEAcwqWoK4wAAAAh0RVh0Q29tbWVudAD2zJa/AAAA
DUlEQVQI12NgYGBgAAAABQABXvMqOgAAAABJRU5ErkJggg==''')

with io.BytesIO(png1x1) as f:
    png1x1_img = Image.open(f)
    png1x1_img.load()

white100x100 = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD//gATQ3JlYXRlZCB3aXRoIEdJTVD/2wBDAKBueIx4ZKCMgoy0
qqC+8P//8Nzc8P//////////////////////////////////////////////////////////2wBD
Aaq0tPDS8P//////////////////////////////////////////////////////////////////
////////////wgARCABkAGQDAREAAhEBAxEB/8QAFQABAQAAAAAAAAAAAAAAAAAAAAL/xAAUAQEA
AAAAAAAAAAAAAAAAAAAA/9oADAMBAAIQAxAAAAGwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD/8QAFBABAAAAAAAAAAAAAAAAAAAA
cP/aAAgBAQABBQIp/8QAFBEBAAAAAAAAAAAAAAAAAAAAcP/aAAgBAwEBPwEp/8QAFBEBAAAAAAAA
AAAAAAAAAAAAcP/aAAgBAgEBPwEp/8QAFBABAAAAAAAAAAAAAAAAAAAAcP/aAAgBAQAGPwIp/8QA
FBABAAAAAAAAAAAAAAAAAAAAcP/aAAgBAQABPyEp/9oADAMBAAIAAwAAABAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAf/8QAFBEB
AAAAAAAAAAAAAAAAAAAAcP/aAAgBAwEBPxAp/8QAFBEBAAAAAAAAAAAAAAAAAAAAcP/aAAgBAgEB
PxAp/8QAFBABAAAAAAAAAAAAAAAAAAAAcP/aAAgBAQABPxAp/9k=''')

with io.BytesIO(white100x100) as f:
    white100x100_img = Image.open(f)
    white100x100_img.load()

white117x100 = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD//gATQ3JlYXRlZCB3aXRoIEdJTVD/2wBDAKBueIx4ZKCMgoy0
qqC+8P//8Nzc8P//////////////////////////////////////////////////////////2wBD
Aaq0tPDS8P//////////////////////////////////////////////////////////////////
////////////wgARCABkAHUDAREAAhEBAxEB/8QAFQABAQAAAAAAAAAAAAAAAAAAAAL/xAAUAQEA
AAAAAAAAAAAAAAAAAAAA/9oADAMBAAIQAxAAAAGwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD//EABQQAQAAAAAA
AAAAAAAAAAAAAHD/2gAIAQEAAQUCQ//EABQRAQAAAAAAAAAAAAAAAAAAAHD/2gAIAQMBAT8BQ//E
ABQRAQAAAAAAAAAAAAAAAAAAAHD/2gAIAQIBAT8BQ//EABQQAQAAAAAAAAAAAAAAAAAAAHD/2gAI
AQEABj8CQ//EABQQAQAAAAAAAAAAAAAAAAAAAHD/2gAIAQEAAT8hQ//aAAwDAQACAAMAAAAQAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAH//xAAUEQEAAAAAAAAAAAAAAAAAAABw/9oACAEDAQE/EEP/xAAUEQEAAAAA
AAAAAAAAAAAAAABw/9oACAECAQE/EEP/xAAUEAEAAAAAAAAAAAAAAAAAAABw/9oACAEBAAE/EEP/
2Q==''')

with io.BytesIO(white117x100) as f:
    white117x100_img = Image.open(f)
    white117x100_img.load()

white100x123 = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD//gATQ3JlYXRlZCB3aXRoIEdJTVD/2wBDAKBueIx4ZKCMgoy0
qqC+8P//8Nzc8P//////////////////////////////////////////////////////////2wBD
Aaq0tPDS8P//////////////////////////////////////////////////////////////////
////////////wgARCAB7AGQDAREAAhEBAxEB/8QAFQABAQAAAAAAAAAAAAAAAAAAAAL/xAAUAQEA
AAAAAAAAAAAAAAAAAAAA/9oADAMBAAIQAxAAAAGwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAf/8QAFBAB
AAAAAAAAAAAAAAAAAAAAcP/aAAgBAQABBQJQ/8QAFBEBAAAAAAAAAAAAAAAAAAAAcP/aAAgBAwEB
PwFQ/8QAFBEBAAAAAAAAAAAAAAAAAAAAcP/aAAgBAgEBPwFQ/8QAFBABAAAAAAAAAAAAAAAAAAAA
cP/aAAgBAQAGPwJQ/8QAFBABAAAAAAAAAAAAAAAAAAAAcP/aAAgBAQABPyFQ/9oADAMBAAIAAwAA
ABAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAD/xAAUEQEAAAAAAAAAAAAAAAAAAABw/9oACAEDAQE/EFD/
xAAUEQEAAAAAAAAAAAAAAAAAAABw/9oACAECAQE/EFD/xAAUEAEAAAAAAAAAAAAAAAAAAABw/9oA
CAEBAAE/EFD/2Q==''')

with io.BytesIO(white100x123) as f:
    white100x123_img = Image.open(f)
    white100x123_img.load()

white150x100 = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD//gATQ3JlYXRlZCB3aXRoIEdJTVD/2wBDAKBueIx4ZKCMgoy0
qqC+8P//8Nzc8P//////////////////////////////////////////////////////////2wBD
Aaq0tPDS8P//////////////////////////////////////////////////////////////////
////////////wgARCABkAJYDAREAAhEBAxEB/8QAFQABAQAAAAAAAAAAAAAAAAAAAAL/xAAUAQEA
AAAAAAAAAAAAAAAAAAAA/9oADAMBAAIQAxAAAAGwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAD/xAAUEAEAAAAAAAAAAAAAAAAAAABw/9oACAEBAAEFAnf/xAAUEQEAAAAAAAAAAAAA
AAAAAABw/9oACAEDAQE/AXf/xAAUEQEAAAAAAAAAAAAAAAAAAABw/9oACAECAQE/AXf/xAAUEAEA
AAAAAAAAAAAAAAAAAABw/9oACAEBAAY/Anf/xAAUEAEAAAAAAAAAAAAAAAAAAABw/9oACAEBAAE/
IXf/2gAMAwEAAgADAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAB//EABQR
AQAAAAAAAAAAAAAAAAAAAHD/2gAIAQMBAT8Qd//EABQRAQAAAAAAAAAAAAAAAAAAAHD/2gAIAQIB
AT8Qd//EABQQAQAAAAAAAAAAAAAAAAAAAHD/2gAIAQEAAT8Qd//Z''')

with io.BytesIO(white150x100) as f:
    white150x100_img = Image.open(f)
    white150x100_img.load()


badexif = base64.b64decode('''
/9j/4AAQSkZJRgABAQEASABIAAD/4QYrRXhpZgAATU0AKgAAAAgACgEPAAIAAAALAAAAhgEQAAIA
AAANAAAAkgEaAAUAAAABAAAAoAEbAAUAAAABAAAAqAEoAAMAAAABAAIAAAExAAIAAAAMAAAAsAEy
AAIAAAAUAAAAvAITAAMAAAABAAEAAIdpAAQAAAABAAAA0IglAAQAAAABAAADBgAAA0hITUQgR2xv
YmFsAABOb2tpYSA3IHBsdXMAAAAAAEgAAAABAAAASAAAAAFHSU1QIDIuOC4xNgAyMDIwOjAxOjEy
IDE2OjQ4OjQwAAAdgpoABQAAAAEAAAIygp0ABQAAAAEAAAI6iCIAAwAAAAEAAAAAiCcAAwAAAAEA
ZAAAkAAABwAAAAQwMjIwkAMAAgAAABQAAAJCkAQAAgAAABQAAAJWkQEABwAAAAQBAgMAkgEACgAA
AAEAAAJqkgIABQAAAAEAAAJykgMACgAAAAEAAAJ6kgcAAwAAAAEAAgAAkgkAAwAAAAEAGAAAkgoA
BQAAAAEAAAKCknwABwAAAEYAAAKKkpAAAgAAAAcAAALQkpEAAgAAAAcAAALYkpIAAgAAAAcAAALg
oAAABwAAAAQwMTAwoAEAAwAAAAEAAQAAoAIABAAAAAEAAAAEoAMABAAAAAEAAAADoAUABAAAAAEA
AALoohcAAwAAAAEAAgAAowEABwAAAAEBAAAApAIAAwAAAAEAAAAApAMAAwAAAAEAAAAApAUAAwAA
AAEABQAApAYAAwAAAAEAAgAAAAAAAAAAAAEAAAEgAAAAyAAAAGQyMDE5OjA3OjA3IDE5OjExOjA0
ADIwMTk6MDc6MDcgMTk6MTE6MDQAAAAf5wAAA+gAAADIAAAAZAAAAhgAAABkAAAN8gAAA+j//40Y
AAArERscNQA1AAAejADoA3wB6gAAAAAACSAAAOgDcAeUARkB+wAAAAAA4wK4AAAAAACGAbAAyQAA
AHoG3ATMAhgCNTg3MTAzAAA1ODcxMDMAADU4NzEwMwAAAAIAAQACAAAABFI5OAAAAgAHAAAABDAx
MDAAAAAAAAIABwAFAAAAAwAAAyQAHQACAAAACwAAAzwAAAAAAAAAEQAAAAEAAAALAAAAAQAAAAQA
AAABMjAxOTowNzowNwAAAAYBAwADAAAAAQAGAAABGgAFAAAAAQAAA5YBGwAFAAAAAQAAA54BKAAD
AAAAAQACAAACAQAEAAAAAQAAA6YCAgAEAAAAAQAAAn0AAAAAAAAASAAAAAEAAABIAAAAAf/Y/+AA
EEpGSUYAAQEAAAEAAQAA/9sAQwAIBgYHBgUIBwcHCQkICgwUDQwLCwwZEhMPFB0aHx4dGhwcICQu
JyAiLCMcHCg3KSwwMTQ0NB8nOT04MjwuMzQy/9sAQwEJCQkMCwwYDQ0YMiEcITIyMjIyMjIyMjIy
MjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIy/8AAEQgAAgADAwEiAAIRAQMR
Af/EAB8AAAEFAQEBAQEBAAAAAAAAAAABAgMEBQYHCAkKC//EALUQAAIBAwMCBAMFBQQEAAABfQEC
AwAEEQUSITFBBhNRYQcicRQygZGhCCNCscEVUtHwJDNicoIJChYXGBkaJSYnKCkqNDU2Nzg5OkNE
RUZHSElKU1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6g4SFhoeIiYqSk5SVlpeYmZqio6Slpqeoqaqy
s7S1tre4ubrCw8TFxsfIycrS09TV1tfY2drh4uPk5ebn6Onq8fLz9PX29/j5+v/EAB8BAAMBAQEB
AQEBAQEAAAAAAAABAgMEBQYHCAkKC//EALURAAIBAgQEAwQHBQQEAAECdwABAgMRBAUhMQYSQVEH
YXETIjKBCBRCkaGxwQkjM1LwFWJy0QoWJDThJfEXGBkaJicoKSo1Njc4OTpDREVGR0hJSlNUVVZX
WFlaY2RlZmdoaWpzdHV2d3h5eoKDhIWGh4iJipKTlJWWl5iZmqKjpKWmp6ipqrKztLW2t7i5usLD
xMXGx8jJytLT1NXW19jZ2uLj5OXm5+jp6vLz9PX29/j5+v/aAAwDAQACEQMRAD8AiEjkZLsT9aKK
K1JR/9n/4QtmaHR0cDovL25zLmFkb2JlLmNvbS94YXAvMS4wLwA8P3hwYWNrZXQgYmVnaW49J++7
vycgaWQ9J1c1TTBNcENlaGlIenJlU3pOVGN6a2M5ZCc/Pgo8eDp4bXBtZXRhIHhtbG5zOng9J2Fk
b2JlOm5zOm1ldGEvJz4KPHJkZjpSREYgeG1sbnM6cmRmPSdodHRwOi8vd3d3LnczLm9yZy8xOTk5
LzAyLzIyLXJkZi1zeW50YXgtbnMjJz4KCiA8cmRmOkRlc2NyaXB0aW9uIHhtbG5zOmV4aWY9J2h0
dHA6Ly9ucy5hZG9iZS5jb20vZXhpZi8xLjAvJz4KICA8ZXhpZjpNYWtlPkhNRCBHbG9iYWw8L2V4
aWY6TWFrZT4KICA8ZXhpZjpNb2RlbD5Ob2tpYSA3IHBsdXM8L2V4aWY6TW9kZWw+CiAgPGV4aWY6
WFJlc29sdXRpb24+NzI8L2V4aWY6WFJlc29sdXRpb24+CiAgPGV4aWY6WVJlc29sdXRpb24+NzI8
L2V4aWY6WVJlc29sdXRpb24+CiAgPGV4aWY6UmVzb2x1dGlvblVuaXQ+SW5jaDwvZXhpZjpSZXNv
bHV0aW9uVW5pdD4KICA8ZXhpZjpTb2Z0d2FyZT5Pbnl4XzAwV1ctdXNlciA5IFBQUjEuMTgwNjEw
LjAxMSAwMFdXXzNfNTRFIHJlbGVhc2Uta2V5c1YxMDAuMDA4Mi4wMVYwMTAuMDAxOS4wNDwvZXhp
ZjpTb2Z0d2FyZT4KICA8ZXhpZjpEYXRlVGltZT4yMDE5OjA3OjA3IDE5OjExOjA0PC9leGlmOkRh
dGVUaW1lPgogIDxleGlmOllDYkNyUG9zaXRpb25pbmc+Q2VudGVyZWQ8L2V4aWY6WUNiQ3JQb3Np
dGlvbmluZz4KICA8ZXhpZjpDb21wcmVzc2lvbj5KUEVHIGNvbXByZXNzaW9uPC9leGlmOkNvbXBy
ZXNzaW9uPgogIDxleGlmOlhSZXNvbHV0aW9uPjcyPC9leGlmOlhSZXNvbHV0aW9uPgogIDxleGlm
OllSZXNvbHV0aW9uPjcyPC9leGlmOllSZXNvbHV0aW9uPgogIDxleGlmOlJlc29sdXRpb25Vbml0
PkluY2g8L2V4aWY6UmVzb2x1dGlvblVuaXQ+CiAgPGV4aWY6RXhwb3N1cmVUaW1lPjEvMjg4IHNl
Yy48L2V4aWY6RXhwb3N1cmVUaW1lPgogIDxleGlmOkZOdW1iZXI+Zi8yLDA8L2V4aWY6Rk51bWJl
cj4KICA8ZXhpZjpFeHBvc3VyZVByb2dyYW0+Tm90IGRlZmluZWQ8L2V4aWY6RXhwb3N1cmVQcm9n
cmFtPgogIDxleGlmOklTT1NwZWVkUmF0aW5ncz4KICAgPHJkZjpTZXE+CiAgICA8cmRmOmxpPjEw
MDwvcmRmOmxpPgogICA8L3JkZjpTZXE+CiAgPC9leGlmOklTT1NwZWVkUmF0aW5ncz4KICA8ZXhp
ZjpFeGlmVmVyc2lvbj5FeGlmIFZlcnNpb24gMi4yPC9leGlmOkV4aWZWZXJzaW9uPgogIDxleGlm
OkRhdGVUaW1lT3JpZ2luYWw+MjAxOTowNzowNyAxOToxMTowNDwvZXhpZjpEYXRlVGltZU9yaWdp
bmFsPgogIDxleGlmOkRhdGVUaW1lRGlnaXRpemVkPjIwMTk6MDc6MDcgMTk6MTE6MDQ8L2V4aWY6
RGF0ZVRpbWVEaWdpdGl6ZWQ+CiAgPGV4aWY6Q29tcG9uZW50c0NvbmZpZ3VyYXRpb24+CiAgIDxy
ZGY6U2VxPgogICAgPHJkZjpsaT5ZIENiIENyIC08L3JkZjpsaT4KICAgPC9yZGY6U2VxPgogIDwv
ZXhpZjpDb21wb25lbnRzQ29uZmlndXJhdGlvbj4KICA8ZXhpZjpTaHV0dGVyU3BlZWRWYWx1ZT44
LDE3IEVWICgxLzI4NyBzZWMuKTwvZXhpZjpTaHV0dGVyU3BlZWRWYWx1ZT4KICA8ZXhpZjpBcGVy
dHVyZVZhbHVlPjIsMDAgRVYgKGYvMiwwKTwvZXhpZjpBcGVydHVyZVZhbHVlPgogIDxleGlmOkJy
aWdodG5lc3NWYWx1ZT41LDM2IEVWICgxNDAsNzIgY2QvbV4yKTwvZXhpZjpCcmlnaHRuZXNzVmFs
dWU+CiAgPGV4aWY6TWV0ZXJpbmdNb2RlPkNlbnRlci13ZWlnaHRlZCBhdmVyYWdlPC9leGlmOk1l
dGVyaW5nTW9kZT4KICA8ZXhpZjpGbGFzaCByZGY6cGFyc2VUeXBlPSdSZXNvdXJjZSc+CiAgPC9l
eGlmOkZsYXNoPgogIDxleGlmOkZvY2FsTGVuZ3RoPjMsNiBtbTwvZXhpZjpGb2NhbExlbmd0aD4K
ICA8ZXhpZjpNYWtlck5vdGU+NzAgYnl0ZXMgdW5kZWZpbmVkIGRhdGE8L2V4aWY6TWFrZXJOb3Rl
PgogIDxleGlmOlN1YnNlY1RpbWU+NTg3MTAzPC9leGlmOlN1YnNlY1RpbWU+CiAgPGV4aWY6U3Vi
U2VjVGltZU9yaWdpbmFsPjU4NzEwMzwvZXhpZjpTdWJTZWNUaW1lT3JpZ2luYWw+CiAgPGV4aWY6
U3ViU2VjVGltZURpZ2l0aXplZD41ODcxMDM8L2V4aWY6U3ViU2VjVGltZURpZ2l0aXplZD4KICA8
ZXhpZjpGbGFzaFBpeFZlcnNpb24+Rmxhc2hQaXggVmVyc2lvbiAxLjA8L2V4aWY6Rmxhc2hQaXhW
ZXJzaW9uPgogIDxleGlmOkNvbG9yU3BhY2U+c1JHQjwvZXhpZjpDb2xvclNwYWNlPgogIDxleGlm
OlBpeGVsWERpbWVuc2lvbj40NjA4PC9leGlmOlBpeGVsWERpbWVuc2lvbj4KICA8ZXhpZjpQaXhl
bFlEaW1lbnNpb24+MzQ1NjwvZXhpZjpQaXhlbFlEaW1lbnNpb24+CiAgPGV4aWY6U2Vuc2luZ01l
dGhvZD5PbmUtY2hpcCBjb2xvciBhcmVhIHNlbnNvcjwvZXhpZjpTZW5zaW5nTWV0aG9kPgogIDxl
eGlmOlNjZW5lVHlwZT5EaXJlY3RseSBwaG90b2dyYXBoZWQ8L2V4aWY6U2NlbmVUeXBlPgogIDxl
eGlmOkV4cG9zdXJlTW9kZT5BdXRvIGV4cG9zdXJlPC9leGlmOkV4cG9zdXJlTW9kZT4KICA8ZXhp
ZjpXaGl0ZUJhbGFuY2U+QXV0byB3aGl0ZSBiYWxhbmNlPC9leGlmOldoaXRlQmFsYW5jZT4KICA8
ZXhpZjpGb2NhbExlbmd0aEluMzVtbUZpbG0+NTwvZXhpZjpGb2NhbExlbmd0aEluMzVtbUZpbG0+
CiAgPGV4aWY6U2NlbmVDYXB0dXJlVHlwZT5Qb3J0cmFpdDwvZXhpZjpTY2VuZUNhcHR1cmVUeXBl
PgogIDxleGlmOkdQU1RpbWVTdGFtcD4xNzoxMTowNCwwMDwvZXhpZjpHUFNUaW1lU3RhbXA+CiAg
PGV4aWY6R1BTRGF0ZVN0YW1wPjIwMTk6MDc6MDc8L2V4aWY6R1BTRGF0ZVN0YW1wPgogIDxleGlm
OkludGVyb3BlcmFiaWxpdHlJbmRleD5SOTg8L2V4aWY6SW50ZXJvcGVyYWJpbGl0eUluZGV4Pgog
IDxleGlmOkludGVyb3BlcmFiaWxpdHlWZXJzaW9uPjAxMDA8L2V4aWY6SW50ZXJvcGVyYWJpbGl0
eVZlcnNpb24+CiA8L3JkZjpEZXNjcmlwdGlvbj4KCjwvcmRmOlJERj4KPC94OnhtcG1ldGE+Cjw/
eHBhY2tldCBlbmQ9J3InPz4K/9sAQwABAQEBAQEBAQEBAQEBAQECAQEBAQECAQEBAgICAgICAgIC
AwMEAwMDAwMCAgMEAwMEBAQEBAIDBQUEBAUEBAQE/9sAQwEBAQEBAQECAQECBAMCAwQEBAQEBAQE
BAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQEBAQE/8IAEQgAAwAEAwERAAIR
AQMRAf/EABQAAQAAAAAAAAAAAAAAAAAAAAL/xAAVAQEBAAAAAAAAAAAAAAAAAAAGB//aAAwDAQAC
EAMQAAABbad//8QAFhABAQEAAAAAAAAAAAAAAAAAAwAC/9oACAEBAAEFAh2q3//EAB8RAAECBgMA
AAAAAAAAAAAAAAECAwAFBhITITEyQ//aAAgBAwEBPwFirJ6LxlT2Pm0eNAbRH//EABwRAQABBAMA
AAAAAAAAAAAAAAECAAMFESJBYv/aAAgBAgEBPwEwuNlYtTYO028pnb6r/8QAHhAAAgEDBQAAAAAA
AAAAAAAAAQIDAAQSETEzYZH/2gAIAQEABj8CkaWe4kbJRk1y5bjQ769n2v/EABcQAQEBAQAAAAAA
AAAAAAAAAAEhABH/2gAIAQEAAT8hVInQtctVVFaqXf/aAAwDAQACAAMAAAAQ/wD/xAAXEQEBAQEA
AAAAAAAAAAAAAAABEQBB/9oACAEDAQE/EC6wCWQUFIAABDsq7//EABgRAQEAAwAAAAAAAAAAAAAA
AAERACHh/9oACAECAQE/EN+cwsW6gCvM/8QAFRABAQAAAAAAAAAAAAAAAAAAARH/2gAIAQEAAT8Q
glv7VRUkpWCqv//Z''')

with io.BytesIO(badexif) as f:
    badexif_img = Image.open(f)
    badexif_img.load()


colorcast = base64.b64decode('''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''')

with io.BytesIO(colorcast) as f:
    colorcast_img = Image.open(f)
    colorcast_img.load()

colorcast_fixed_001 = base64.b64decode('''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==
''')


colorcast_fixed_002 = base64.b64decode('''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''')


colorcast_fixed_003 = base64.b64decode('''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''')


colorcast_fixed_005 = base64.b64decode('''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''')
